﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectAircraftCarrier.DrawingObjects;

namespace ProjectAircraftCarrier.MovementStrategy
{
    /// <summary>
    /// Реализация интерфейса IdrawingObject для работы с объектом drawingCar (паттерн Adapter)
    /// </summary>
    public class DrawingObjectWarship : IMoveableObject
    {
        private readonly DrawingWarship? _drawingWarship = null;
        public DrawingObjectWarship(DrawingWarship drawingWarship)
        {
            _drawingWarship = drawingWarship;
        }
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawingWarship == null || _drawingWarship.EntityWarship ==
                null)
                {
                    return null;
                }
                return new ObjectParameters(_drawingWarship.GetPosX,
                    _drawingWarship.GetPosY, _drawingWarship.GetWidth, 
                    _drawingWarship.GetHeight);
            }
        }
        public int GetStep => (int)(_drawingWarship?.EntityWarship?.Step ?? 0);
        public bool CheckCanMove(DirectionType direction) =>
        _drawingWarship?.CanMove(direction) ?? false;
        public void MoveObject(DirectionType direction) =>
        _drawingWarship?.MoveTransport(direction);
    }
}
