﻿using ProjectAircraftCarrier.DrawingObjects;
using ProjectAircraftCarrier.Entities;
using System.Diagnostics.CodeAnalysis;
namespace ProjectAircraftCarrier.Generics
{
    internal class DrawingWarshipEqutables : IEqualityComparer<DrawingWarship?>
    {
        public bool Equals(DrawingWarship? x, DrawingWarship? y)
        {
            if (x == null || x.EntityWarship == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityWarship == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return false;
            }
            if (x.EntityWarship.Speed != y.EntityWarship.Speed)
            {
                return false;
            }
            if (x.EntityWarship.Weight != y.EntityWarship.Weight)
            {
                return false;
            }
            if (x.EntityWarship.BodyColor != y.EntityWarship.BodyColor)
            {
                return false;
            }
            if (x is DrawingAircraftCarrier && y is DrawingAircraftCarrier)
            {
                EntityAircraftCarrier EntityX = 
                    (EntityAircraftCarrier)x.EntityWarship;
                EntityAircraftCarrier EntityY = 
                    (EntityAircraftCarrier)y.EntityWarship;
                if (EntityX.Runway != EntityY.Runway)
                    return false;
                if (EntityX.Cabin != EntityY.Cabin)
                    return false;
                if (EntityX.AdditionalColor != EntityY.AdditionalColor)
                    return false;
            }
            return true;
        }
        public int GetHashCode([DisallowNull] DrawingWarship obj)
        {
            return obj.GetHashCode();
        }
    }
}
