﻿using ProjectAircraftCarrier.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectAircraftCarrier.Entities
{
    /// <summary>
    /// Класс-сущность "Спортивный автомобиль"
    /// </summary>
    public class EntityAircraftCarrier : EntityWarship
    {
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; private set; }
        /// <summary>
        /// Признак (опция) наличия антикрыла
        /// </summary>
        public bool Runway { get; private set; }
        /// <summary>
        /// Признак (опция) наличия гоночной полосы
        /// </summary>
        public bool Cabin { get; private set; }
        /// <summary>
        /// Инициализация полей объекта-класса спортивного автомобиля
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="runway">Признак наличия антикрыла</param>
        /// <param name="cabin">Признак наличия гоночной полосы</param>
        public EntityAircraftCarrier(int speed, double weight, Color bodyColor, Color additionalColor, bool runway, bool cabin)
            : base(speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            Runway = runway;
            Cabin = cabin;
        }
        public void ChangeAddColor(Color color) { AdditionalColor = color; }
    }
}