﻿using ProjectAircraftCarrier.DrawingObjects;
namespace ProjectAircraftCarrier.Generics
{
    internal class WarshipCompareByColor : IComparer<DrawingWarship?>
    {
        public int Compare(DrawingWarship? x, DrawingWarship? y)
        {
            if (x == null || x.EntityWarship == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityWarship == null)
                throw new ArgumentNullException(nameof(y));

            if (x.EntityWarship.BodyColor.Name != 
                y.EntityWarship.BodyColor.Name)
            {
                return x.EntityWarship.BodyColor.Name.CompareTo
                    (y.EntityWarship.BodyColor.Name);
            }

            var speedCompare = x.EntityWarship.Speed.CompareTo
                (y.EntityWarship.Speed);
            if (speedCompare != 0)
                return speedCompare;

            return x.EntityWarship.Weight.CompareTo(y.EntityWarship.Weight);
        }
    }
}