﻿using ProjectAircraftCarrier.DrawingObjects;
namespace ProjectAircraftCarrier.Generics
{
    internal class WarshipCompareByType : IComparer<DrawingWarship?>
    {
        public int Compare(DrawingWarship? x, DrawingWarship? y)
        {
            if (x == null || x.EntityWarship == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityWarship == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = 
                x.EntityWarship.Speed.CompareTo(y.EntityWarship.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityWarship.Weight.CompareTo(y.EntityWarship.Weight);
        }
    }
}
