﻿namespace ProjectAircraftCarrier.Generics
{
    internal class WarshipsCollectionInfo : IEquatable<WarshipsCollectionInfo>
    {
        public string Name { get; private set; }
        public string Description { get; private set; }
        public WarshipsCollectionInfo(string name, string description)
        {
            Name = name;
            Description = description;
        }
        public bool Equals(WarshipsCollectionInfo? other)
        {
            if (other == null || other.Name == null)
                throw new ArgumentNullException(nameof(other));
            return Name == other.Name;
        }
        public override int GetHashCode()
        {
            return this.Name.GetHashCode();
        }
    }
}

